package sdk

import "encoding/json"

//商品

//GoodsList 商品列表
func (c *Client) GoodsList(req map[string]interface{}) (res *GoodsListRes, err error) {
	method := "/local/goods"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Get(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//GoodsInfo 商品详情
func (c *Client) GoodsInfo(req map[string]interface{}) (res *GoodsInfoRes, err error) {
	method := "/local/goods/:"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Get(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//CreateGoods 添加商品
func (c *Client) CreateGoods(req map[string]interface{}) (res *CreateGoodsRes, err error) {
	method := "/local/goods"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//EditGoods 编辑商品
func (c *Client) EditGoods(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/goods"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.PUT(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//DoShelves 商品上下架
func (c *Client) DoShelves(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/goods"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Patch(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//OnSaleUpdate 不下架编辑
func (c *Client) OnSaleUpdate(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/goods/onsaleUpdate"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//GoodsStock 商品库存 数组性传参
func (c *Client) GoodsStock(req []map[string]interface{}) (res *GetStockRes, err error) {
	method := "/local/goods/stock"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Get(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//GoodsOperate 商品操作，上下架
func (c *Client) GoodsOperate(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/GoodsOperate"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//GoodsOperateAll 商品操作，上下架
func (c *Client) GoodsOperateAll(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/GoodsOperateAll"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//GoodsStockUpdate 商品库存修改
func (c *Client) GoodsStockUpdate(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/GoodsStockUpdate"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Get(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//DoGoodsStatus 删除 彻底删除 还原商品
func (c *Client) DoGoodsStatus(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/doGoodsStatus"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//Collect 反向增加商品
func (c *Client) Collect(req map[string]interface{}) (res *GoodsCollectRes, err error) {
	method := "/local/collect"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//CancelOnSale 取消审核
func (c *Client) CancelOnSale(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/CancelOnsale"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//CancelOnSaleAll 批量取消审核
func (c *Client) CancelOnSaleAll(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/CancelOnsaleAll"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//CategoryUpdate 修改商品类目
func (c *Client) CategoryUpdate(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/category/update"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//SysLogSave 保存备注
func (c *Client) SysLogSave(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/sysLog/save"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//Stags 服务标签
func (c *Client) Stags(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/stags"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Get(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//PushGoods 渠道推送商品
func (c *Client) PushGoods(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/pushGoods"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//CancelPush 渠道撤回推送商品
func (c *Client) CancelPush(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/cancelPush"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}

//ChannelAudit 渠道推送商品审核操作
func (c *Client) ChannelAudit(req map[string]interface{}) (res *GoodsCommonRes, err error) {
	method := "/local/channelAudit"
	param := req
	data, _ := json.Marshal(param)
	resData, err := c.Post(method, string(data))
	if err != nil {
		return
	}
	err = json.Unmarshal(resData, &res)
	return
}
